Tool to help do some analysis on the jussi log files.
This tool is written in Java, using version 8 so you'll need a v8 JRE to run it.

<b>Ubuntu:</b>
```
sudo apt install openjdk-8-jre
```

<b>Windows</b>

https://www.oracle.com/java/technologies/javase-jre8-downloads.html

There is a pre-compiled version of the tool at the root of this directory. If you just want to use the tool without building it, download JussiTrafficAnalyzer.jar from the top level of this project. The required libraries are packaged into it already, so as long as you have a JRE you should be good to go.

Run the tool with the standard java command:
```
java -jar JussiTrafficAnalyzer.jar
```

Providing no arguments or passing -h or --help will cause the tool to print the available options.

<b>Notes about Nginx Log File:</b>

The tool expects the log file to follow a specific format. Add the following lines near the top of your nginx configuration file (on linux this is found at <b>/etc/nginx/sites-available/default</b>):
```
log_format api_log '$remote_addr - $remote_user || [$time_local] || "$request" || '
                                '$status || $body_bytes_sent || "$http_referer" || '
                                '"$http_user_agent" || "$http_x_forwarded_for" || '
                                '"$upstream_http_x_jussi_cache_hit" || "$upstream_http_x_jussi_namespace" || '
                                '"$upstream_http_x_jussi_api" || "$upstream_http_x_jussi_method" || "$upstream_http_x_jussi_params" || '
                                '$upstream_connect_time || $upstream_response_time';
```

and then down in the server section of the file add the line:
```
access_log /var/log/jussi/access.log api_log buffer=32k flush=5s;
```

<b>Do an Analysis</b>

*Step 1: Download the log file from the server*
```
scp root@<redacted>:/var/log/jussi/access.log .
```

*Step 2: Run the tool*
```
java -jar JussiTrafficAnalyzer.jar -i <path to access.log from step 1> -o <path where output files will be saved> -s <Starting Timestamp> -e <Ending Timestamp> -l 3
```
You'll see some messages get printed to standard out along the way as the tool preforms various steps. Eventually you should see output indicating that it has finished running and it will give you the full path to the analysis file and to the slow calls log file if one was generated.

<b>Note on Timestamps<b>

Timestamps are also expected to follow a specific format: DD/mmm/YYYY:HH:MM:SS -- example 20/Oct/2020:15:00:00

The timestamps in the production log file are in GMT time, so convert accordingly.

*Step 3: Import the CSV file into LibreOffice*

If LibreOffice Calc is  your default application for CSV files, double clicking analysis.csv should open it in libre office for you. If not, open LibreOffice Calc and then do File -> Open and select the results file. Do a quick Ctrl+A to select the data, then on the top menu bar click on Data and then AutoFilter. Now you can sort the fields and create views however you like. At this point it's recommended to save the file in the ODF format instead of CSV.


<b>Development<b>

The code was written in the eclipse IDE so the structure follows the eclipse workspace structure. You'll need to download and link the json-simple.1.1.1.jar file that is at the root of this project to be able to parse the json entries in the log file.
